#ifndef __TEXPROJECT_H__
#define __TEXPROJECT_H__

#include <vector>
//#include <ablib/KRSearch.h>
//#include "CollectStr.h"
//#include "BibTeX.h"

/**
TeX̕t@CɊւ񋟂NXD
ŝŁCBibǗ͂̒D

vD
*/

class TeXProject
{
public:
	struct FileData{
		enum Type{input,include,main};
		FileData(Type t,const TCHAR *n) : type(t),name(n){}
		FileData(Type t,const ablib::string &n) : type(t),name(n){}
		ablib::string name;
		Type type;
	};

	TeXProject(){}
	~TeXProject(){}
	/// fileet@CƂāCinputincludeĂt@C̃Xg
	int CreateFileList(const TCHAR *file);
	/// Xgɂt@CԂDԍŏɂ̓Ct@CAD
	const TCHAR *GetFile();
	/// et@C𐄒聕D\documentclass̃IvVNXt@C擾D
	const TCHAR *FindParentFile(const TCHAR *file);
	/// FindParentFileŎ擾\documentclass̃IvV擾D
	const TCHAR *GetDocumentOption() const{return m_option.c_str();}
	/// FindParentFileŎ擾hLgNX擾D
	const TCHAR *GetDocumentClass() const{return m_docclass.c_str();}
	/*
	int CollectSet(const TCHAR *set,const TCHAR *val){return m_cs.Set(set,val);}
	int Collect(const TCHAR *nowfile,const TCHAR *reg,const TCHAR *getstr);
	int CollectGetDataSize(){return m_cs.GetDataSize();}
	const TCHAR *CollectGetStr(int i){return m_cs.GetStr(i);}
	const TCHAR *CollectGetComment(int i){return m_cs.GetComment(i);}
	int CollectGetLine(int i){return m_cs.GetLine(i);}
	const TCHAR *CollectGetFileName(int i);
	int CollectClear(){m_collectsizes.clear();return m_cs.ClearStr();}
	*/
	int kpsewhich(const TCHAR *file,const TCHAR *dir,const TCHAR *progname);
	const TCHAR *GetKpsewhich(int i){if(i < 0 || i >= static_cast<int>(m_kpsewhich.size()))return _T("");else return m_kpsewhich[i].c_str();}
	std::vector<FileData> GetFileData() const{return m_files;}

	/*
	int Bib_CreateFileList();
	int Bib_Analyze(){return m_bibtex.AnalyzeBib();}
	int Bib_SearchDlg(HWND hwnd,const TCHAR *ini){return m_bibtex.SearchDlg(hwnd,ini);}
	const TCHAR *Bib_ShowResult(HWND hwnd,const TCHAR *ini){return m_bibtex.ShowResult(hwnd,ini);}
	int Bib_ToFile(const TCHAR *label,const TCHAR *other){m_bibtex.ToFile(label,other);return FALSE;}
	*/

private:
	ablib::string m_option,m_docclass;
	std::vector<FileData> m_files;
	std::vector<ablib::string> m_kpsewhich;
	UINT m_num;
	void CreateList(const TCHAR *file);
	
	const TCHAR *FindParent(const ablib::string &me);
	ablib::string GetInput(const TCHAR *str, const ablib::string &dir, const TCHAR *key);
	bool SearchDocumentClass(const ablib::string &file, ablib::string &option, ablib::string &doccls, bool *inputfilecheck, const TCHAR *chkinputfile);

	/*
	CollectStr m_cs;
	std::vector<int> m_collectsizes;
	*/

	ablib::string Exec_kpsewhich(const TCHAR *f,const TCHAR *d,const TCHAR *p);
	//BibTeX m_bibtex;
	NOCOPY(TeXProject);
};

#endif //__TEXPROJECT_H__

