#include "stdafx.h"
#include "dvi2psset.h"
#include "Setting.h"
#include "resource.h"

extern Setting g_setting;

bool DVI2PSSet::OnInitDialog(ablib::window::Dialog *wnd){
	switch(g_setting.DVI2PS_WhichProgram()){
	case dvi2ps:
		ablib::window::CheckBox(wnd,IDC_DVI2PS).SetCheck(true);
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(true);
		break;

	case other:
		ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).SetCheck(true);
		break;

	case dvipsk:
	default:
		ablib::window::CheckBox(wnd,IDC_DVIPSK).SetCheck(true);
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(true);
		break;
	}
	ablib::window::Edit(wnd,IDC_PROGRAM).SetText(g_setting.DVI2PS_Program());
	ablib::window::Edit(wnd,IDC_OPTION).SetText(g_setting.DVI2PS_Option());
	return true;
}

bool DVI2PSSet::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_DVI2PS:
	case IDC_DVIPSK:
	case IDC_OTHERPROGRAM:
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		return true;

	case IDOK:
		if(ablib::window::CheckBox(wnd,IDC_DVI2PS).GetCheck())g_setting.WriteDVI2PS_WhichProgram(dvi2ps);
		else if(ablib::window::CheckBox(wnd,IDC_DVIPSK).GetCheck())g_setting.WriteDVI2PS_WhichProgram(dvipsk);
		else g_setting.WriteDVI2PS_WhichProgram(other);
		g_setting.WriteDVI2PS_Program(ablib::window::Edit(wnd,IDC_PROGRAM).GetText());
		g_setting.WriteDVI2PS_Option(ablib::window::Edit(wnd,IDC_OPTION).GetText());
		wnd->Destroy(TRUE);
		return true;

	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}




