#include "stdafx.h"
#include "makeindexset.h"
#include "setting.h"
#include "resource.h"

extern Setting g_setting;

bool MakeIndexSet::OnInitDialog(ablib::window::Dialog *wnd){
	switch(g_setting.MakeIndex_WhichProgram()){
	case makeindex:
		ablib::window::CheckBox(wnd,IDC_MAKEINDEX).SetCheck(true);
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(true);
		break;

	case other:
		ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).SetCheck(true);
		break;

	case mendex:
	default:
		ablib::window::CheckBox(wnd,IDC_MENDEX).SetCheck(true);
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(true);
		break;
	}
	ablib::window::Edit(wnd,IDC_PROGRAM).SetText(g_setting.MakeIndex_Program());
	ablib::window::Edit(wnd,IDC_OPTION).SetText(g_setting.MakeIndex_Option());
	return true;
}

bool MakeIndexSet::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_MAKEINDEX:
	case IDC_MENDEX:
	case IDC_OTHERPROGRAM:
		ablib::window::Edit(wnd,IDC_PROGRAM).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck());
		return true;
		
	case IDOK:
		if(ablib::window::CheckBox(wnd,IDC_MAKEINDEX).GetCheck()){
			g_setting.WriteMakeIndex_WhichProgram(makeindex);
		}else if(ablib::window::CheckBox(wnd,IDC_OTHERPROGRAM).GetCheck()){
			g_setting.WriteMakeIndex_WhichProgram(other);
		}else{
			g_setting.WriteMakeIndex_WhichProgram(mendex);
		}
		g_setting.WriteMakeIndex_Program(ablib::window::Edit(wnd,IDC_PROGRAM).GetText());
		g_setting.WriteMakeIndex_Option(ablib::window::Edit(wnd,IDC_OPTION).GetText());
		wnd->Destroy(TRUE);
		return true;

	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}

