#include "stdafx.h"
#include "previewset.h"
#include "Setting.h"
#include "resource.h"

extern Setting g_setting;

bool PreviewSet::OnInitDialog(ablib::window::Dialog *wnd){
	ablib::window::Edit(wnd,IDC_PSPREVIEW).SetText(g_setting.PSPreview_Program());
	ablib::window::Edit(wnd,IDC_PSARG).SetText(g_setting.PSPreview_Arg());
	ablib::window::Edit(wnd,IDC_PDFPREVIEW).SetText(g_setting.PDFPreview_Program());
	ablib::window::Edit(wnd,IDC_PDFARG).SetText(g_setting.PDFPreview_Arg());
	return true;
}

bool PreviewSet::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_PSSANSYO:
	{
		ablib::string ps = ablib::window::Edit(wnd,IDC_PSPREVIEW).GetText();
		if(ablib::window::CommonDlg(wnd).OpenFileDlg(
			ps,
			_T("st@C\0*.exe\0SẴt@C\0*.*\0"),
			_T("PS{p\tgIłD"),
			ps.c_str()))
			ablib::window::Edit(wnd,IDC_PSPREVIEW).SetText(ps);
		return true;
	}
	case IDC_PDFSANSYO:
	{
		ablib::string pdf = ablib::window::Edit(wnd,IDC_PDFPREVIEW).GetText();
		if(ablib::window::CommonDlg(wnd).OpenFileDlg(
			pdf,
			_T("st@C\0*.exe\0SẴt@C\0*.*\0"),
			_T("PDF{p\tgIłD"),
			pdf.c_str()))
			ablib::window::Edit(wnd,IDC_PDFPREVIEW).SetText(pdf);
		return true;
	}
	case IDOK:
		g_setting.WritePSPreview_Program(ablib::window::Edit(wnd,IDC_PSPREVIEW).GetText());
		g_setting.WritePSPreview_Arg(ablib::window::Edit(wnd,IDC_PSARG).GetText());
		g_setting.WritePDFPreview_Program(ablib::window::Edit(wnd,IDC_PDFPREVIEW).GetText());
		g_setting.WritePDFPreview_Arg(ablib::window::Edit(wnd,IDC_PDFARG).GetText());
		wnd->Destroy(TRUE);
		return true;

	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}




