#include "stdafx.h"
#include "texset.h"
#include "resource.h"
#include "Setting.h"

extern Setting g_setting;


bool TeXSet::OnInitDialog(ablib::window::Dialog *wnd){
	switch(g_setting.TeX_WhichParent()){
	case now:
		ablib::window::CheckBox(wnd,IDC_NOWFILE).SetCheck(true);
		break;

	case sitei:
		ablib::window::CheckBox(wnd,IDC_SITEI).SetCheck(true);
		break;

	case guess:
	default:
		ablib::window::CheckBox(wnd,IDC_GUESS).SetCheck(true);
		break;
	}
	ablib::window::Edit(wnd,IDC_PARENTFILE).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_SITEI).GetCheck());
	ablib::window::Edit(wnd,IDC_PARENTFILE).SetText(g_setting.TeX_Parent());
	return true;
}

bool TeXSet::OnCommand(ablib::window::Dialog *wnd,int id,int param){
	switch(id){
	case IDC_NOWFILE:
	case IDC_SITEI:
	case IDC_GUESS:
		ablib::window::Edit(wnd,IDC_PARENTFILE).SetReadOnly(!ablib::window::CheckBox(wnd,IDC_SITEI).GetCheck());
		return true;

	case IDC_SANSYO_PARENT:
		if(ablib::window::CheckBox(wnd,IDC_SITEI).GetCheck()){
			ablib::string s;
			if(ablib::window::CommonDlg(wnd).OpenFileDlg(s,
				_T("TeXt@C(*.tex)\0*.tex\0SẴt@C(*.*)\0*.*\0"),
				_T("et@CIłD"),
				ablib::window::Edit(wnd,IDC_PARENTFILE).GetText().c_str()))ablib::window::Edit(wnd,IDC_PARENTFILE).SetText(s);
		}
		return true;


	case IDOK:
		if(ablib::window::CheckBox(wnd,IDC_GUESS).GetCheck()){
			g_setting.WriteTeX_WhichParent(guess);
		}else if(ablib::window::CheckBox(wnd,IDC_SITEI).GetCheck()){
			g_setting.WriteTeX_WhichParent(sitei);
		}else{
			g_setting.WriteTeX_WhichParent(now);
		}
		g_setting.WriteTeX_Parent(ablib::window::Edit(wnd,IDC_PARENTFILE).GetText());
		wnd->Destroy(TRUE);
		return true;

	case IDCANCEL:
		wnd->Destroy(FALSE);
		return true;

	default:
		return false;
	}
}
	